"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudIntegrationGcp = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Wavefront Cloud Integration for Google Cloud Platform. This allows Google Cloud Platform cloud
 * integrations to be created, updated, and deleted.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as wavefront from "@pulumi/wavefront";
 *
 * const gcp = new wavefront.CloudIntegrationGcp("gcp", {
 *     name: "Test Integration",
 *     projectId: "example-gcp-project",
 *     jsonKey: "{...your gcp key ...}\n",
 * });
 * ```
 *
 * ## Import
 *
 * GCP Cloud Integrations can be imported by using the `id`, e.g.:
 *
 * ```sh
 * $ pulumi import wavefront:index/cloudIntegrationGcp:CloudIntegrationGcp gcp a411c16b-3cf7-4f03-bf11-8ca05aab898d
 * ```
 */
class CloudIntegrationGcp extends pulumi.CustomResource {
    /**
     * Get an existing CloudIntegrationGcp resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new CloudIntegrationGcp(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of CloudIntegrationGcp.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === CloudIntegrationGcp.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["additionalTags"] = state ? state.additionalTags : undefined;
            resourceInputs["categories"] = state ? state.categories : undefined;
            resourceInputs["forceSave"] = state ? state.forceSave : undefined;
            resourceInputs["jsonKey"] = state ? state.jsonKey : undefined;
            resourceInputs["metricFilterRegex"] = state ? state.metricFilterRegex : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["projectId"] = state ? state.projectId : undefined;
            resourceInputs["service"] = state ? state.service : undefined;
            resourceInputs["serviceRefreshRateInMinutes"] = state ? state.serviceRefreshRateInMinutes : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.jsonKey === undefined) && !opts.urn) {
                throw new Error("Missing required property 'jsonKey'");
            }
            if ((!args || args.projectId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'projectId'");
            }
            if ((!args || args.service === undefined) && !opts.urn) {
                throw new Error("Missing required property 'service'");
            }
            resourceInputs["additionalTags"] = args ? args.additionalTags : undefined;
            resourceInputs["categories"] = args ? args.categories : undefined;
            resourceInputs["forceSave"] = args ? args.forceSave : undefined;
            resourceInputs["jsonKey"] = (args === null || args === void 0 ? void 0 : args.jsonKey) ? pulumi.secret(args.jsonKey) : undefined;
            resourceInputs["metricFilterRegex"] = args ? args.metricFilterRegex : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["projectId"] = args ? args.projectId : undefined;
            resourceInputs["service"] = args ? args.service : undefined;
            resourceInputs["serviceRefreshRateInMinutes"] = args ? args.serviceRefreshRateInMinutes : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        const secretOpts = { additionalSecretOutputs: ["jsonKey"] };
        opts = pulumi.mergeOptions(opts, secretOpts);
        super(CloudIntegrationGcp.__pulumiType, name, resourceInputs, opts);
    }
}
exports.CloudIntegrationGcp = CloudIntegrationGcp;
/** @internal */
CloudIntegrationGcp.__pulumiType = 'wavefront:index/cloudIntegrationGcp:CloudIntegrationGcp';
//# sourceMappingURL=cloudIntegrationGcp.js.map